//	DevHndle.hpp

#ifndef	__DEVHNDLE_HPP__
#define	__DEVHNDLE_HPP__

#include "windows.h"

void showError( const char* _msg);

class	HandleW32Exception
{
};

class	DevHandleW32Exception : public HandleW32Exception
{
};

//class	DevHandleW32;		// forward declaration for friend

//////////////////////////////////////////////////////////////////////////////
//
// class	HandleW32
//
class	HandleW32
{
private:
	HandleW32();
	HandleW32( LPCTSTR _name, DWORD _access, DWORD _create );
	HandleW32( const HandleW32& _dh );

	~HandleW32();

	void Connect( LPCTSTR _name, DWORD _access, DWORD _create );
	void Connect();
	void DisConnect();

	void ReConnect();
	void ConnectHandle();
	void CloseHandle();
	
	operator 	HANDLE () const { return hDev; }
	HANDLE 		Handle() const { return hDev; }
	LPCTSTR		Name() const { return name; }
	DWORD		AccessMode() const { return	access; }
	DWORD		CreateMode() const { return	create; }
	bool		Connected() const { return connected; }
	
	void		Set( LPCTSTR _name, DWORD _access, DWORD _create );
	void		Set( const HandleW32& _dh );
	
	
	WString			name;		// name of file/device to be opened	
	DWORD			access;		// access parameters
	DWORD			create;		// creation/connection parameters 

    HANDLE  		hDev;    	// Handle to device.
	int				hCount;		// hendle reference count
	bool			connected;	// true if have valid handle, else false
	
	friend	class	DevHandleW32;
};

//////////////////////////////////////////////////////////////////////////////
//
// class	DevHandleW32
//
class	DevHandleW32
{
public:
	DevHandleW32();
	DevHandleW32( LPCTSTR _name, DWORD _access, DWORD _create );
	DevHandleW32( const DevHandleW32& _dh );

	~DevHandleW32();

	void Connect( LPCTSTR _name, DWORD _access, DWORD _create );
	void Connect( const DevHandleW32& _dh ) ;
	
	void DisConnect();
	void ReConnect();

	bool operator == ( DevHandleW32 const & _dh ) const { return hDev == _dh.hDev; }
		
	operator HANDLE () const;
	HANDLE Handle() const;
	
	LPCTSTR		Name() const { if ( hDev ) return hDev->Name(); return 0; }
	DWORD		AccessMode() const { if ( hDev ) return	hDev->AccessMode(); return 0; }
	DWORD		CreateMode() const { if ( hDev ) return	hDev->CreateMode(); return 0; }
	bool		Connected() const { if ( hDev ) return	hDev->Connected(); return 0; }
	
private:
    HandleW32* 		hDev;    	// Handle to device.
};

#include "DevHndle.cpp"		// until create library

#endif	// __DEVHNDLE_HPP__
