//	PortSet.hpp

#ifndef __PORTSET_HPP__
#define __PORTSET_HPP__

#ifndef  uint
typedef unsigned int  uint;
#endif


//////////////////////////////////////////////////////////////////////////////
//
// class	PortSettings 
//
class	PortSettings
{
public:
	enum	General
	{
		DefBaud		= 9600,
		DefDB		= 8,
		DefPar		= 0,
		DefSB		= 1,
		
		StringLen	= 100
	};
	
	PortSettings( uint _br=DefBaud, uint _db=DefDB, uint _p=DefPar, uint _sb=DefSB );
	explicit PortSettings( char* _str );
	
	PortSettings& operator = ( const PortSettings& _ps );
	
	const char* 	String() const ;
	operator		const char* () const { return String(); }

	void	Set( uint _br );
	void	Set( uint _br, uint _db );
	void	Set( uint _br, uint _db, uint _p );
	void	Set( uint _br, uint _db, uint _p, uint _sb );
	void 	Set( char const * _str );
	void	ReSet() { Set( DefBaud, DefDB, DefPar, DefSB ); }

	uint	BaudRate() 	const { return baudRate; }
	uint 	DataBits() 	const { return dataBits; }
	uint	Parity() 	const { return parity; }
	uint	StopBits() 	const { return stopBits; }	
	
	static const char*	IniText();
	static void	skipNonDigitsAnd1stZero( istream& _is );

private:
	long	baudRate;
	uint 	dataBits;
	uint	parity;
	uint	stopBits;
	
	mutable char  	stringBuf[StringLen+1];		// used by String(). Do NOT alter
};

#include "PortSet.cpp"		// until create library

#endif