//	QueEx.hpp
//
//  Declaration for QueueException class
	
#ifndef __QUEEX__HPP__
#define __QUEEX__HPP__

#ifndef  uint
typedef unsigned int  uint;
#endif


#ifdef USING
namespace ktUtil
{
#endif

//===========================================================================//
//  class QueueException
//
//  Implements a simple circular queue, allowing overwrites
//
//	Provides methods which allow creation of a QueueException & querying
//	of the error status.
//===========================================================================//
//
class	QueueException
{
public:
	enum	Flags
	{
		Ok			= 0,	// no problems, all is Ok
		NoQueueMem	= 1,	// fatal error. Unable to alloc mem for queue store.
		EmptyQ		= 2,	// Error caused by accessing empty queue
		FullQ		= 3,	// Error caused by accessing full queue
		OutsideQ	= 4		// Error caused by access outside queue store
	};
	
	QueueException( Flags _err=Ok ) : errCode(_err) {}
	
	uint	ErrCode() const { return errCode; }
	operator const char* () const { return ErrString[errCode]; }
private:
	Flags			errCode;		// 
	static char*	ErrString[];
};

char*	QueueException::ErrString[] = 
	{ "Ok", "No memory for Queue", "Empty Queue", "Full Queue", "Outside Queue", 0 };


#ifdef USING
}		// namespace ktUtil
#endif

#endif	// __QUEEX__HPP__